=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-11-11 17:26:22 +0000
+++ bzrlib/builtins.py	2005-11-16 04:28:26 +0000
@@ -29,7 +29,7 @@
 from bzrlib.revision import common_ancestor
 from bzrlib.errors import (BzrError, BzrCheckError, BzrCommandError, 
                            NotBranchError, DivergedBranches, NotConflicted,
-			   NoSuchFile, NoWorkingTree)
+			   NoSuchFile, NoWorkingTree, FileInWrongBranch)
 from bzrlib.option import Option
 from bzrlib.revisionspec import RevisionSpec
 import bzrlib.trace
@@ -40,9 +40,10 @@
 def branch_files(file_list, default_branch='.'):
     try:
         return inner_branch_files(file_list, default_branch)
-    except NotBranchError:
+    except FileInWrongBranch, e:
+        print file_list
         raise BzrCommandError("%s is not in the same branch as %s" %
-                             (filename, file_list[0]))
+                             (e.path, file_list[0]))
 
 def inner_branch_files(file_list, default_branch='.'):
     """\
@@ -61,7 +62,10 @@
     tree = WorkingTree(b.base, b)
     new_list = []
     for filename in file_list:
-        new_list.append(tree.relpath(filename))
+        try:
+            new_list.append(tree.relpath(filename))
+        except NotBranchError:
+            raise FileInWrongBranch(b, filename)
     return b, new_list
 
 
@@ -732,7 +736,7 @@
         try:
             b, file_list = inner_branch_files(file_list)
             b2 = None
-        except NotBranchError:
+        except FileInWrongBranch:
             if len(file_list) != 2:
                 raise BzrCommandError("Files are in different branches")
 

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2005-11-15 21:09:09 +0000
+++ bzrlib/errors.py	2005-11-16 04:28:26 +0000
@@ -157,6 +157,15 @@
         self.path = path
 
 
+class FileInWrongBranch(BzrNewError):
+    """File %(path)s in not in branch %(branch_base)s."""
+    def __init__(self, branch, path):
+        BzrNewError.__init__(self)
+        self.branch = branch
+        self.branch_base = branch.base
+        self.path = path
+
+
 class UnsupportedFormatError(BzrError):
     """Specified path is a bzr branch that we cannot read."""
     def __str__(self):

